<?php
/*
+---------------------------------------------------------------+
|        e107 website system
|        code adapted from original by Lolo Irie (lolo@touchatou.com)
|
|        Steve Dunstan 2001-2002
|        http://e107.org
|        jalist@e107.org
|
|        Released under the terms and conditions of the
|        GNU General Public License (http://gnu.org).
+---------------------------------------------------------------+
*/
// Plugin info -------------------------------------------------------------------------------------------------------
$eplug_name = "E107 Tracker";
$eplug_version = "1.0";
$eplug_author = "Brandon Tiesman";
$eplug_logo = "/images/icon.gif";
$eplug_url = "http://e107coders.org";
$eplug_email = "kjtiesman11@mchsi.com";
$eplug_description = "This Plugin will Give You BitTorrent Tracking Capabilities on Your e107 Website.";
$eplug_compatible = "e107v6";
$eplug_readme = "readme.txt";        // leave blank if no readme file

// Name of the plugin's folder -------------------------------------------------------------------------------------
$eplug_folder = "bt_e107";

// Name of the admin configuration file --------------------------------------------------------------------------
$eplug_conffile = "deleter.php";

// Icon image and caption text ------------------------------------------------------------------------------------
$eplug_icon = $eplug_folder."/images/icon.gif";
$eplug_caption =  "Tracker Options";

// Mane of menu item for plugin ----------------------------------------------------------------------------------
$eplug_menu_name = "bte107_menu";

// List of preferences -----------------------------------------------------------------------------------------------
$eplug_prefs = array(
        "tracker_1" => 0 // this stores a default value in the preferences.0 = off , 1= On
);


// List of table names -----------------------------------------------------------------------------------------------
$eplug_table_names = array(
        "tracker",
        "namemap",
        "summary",
        "timestamps"
);


// List of sql requests to create tables -----------------------------------------------------------------------------
$eplug_tables = array(
"CREATE TABLE ".MPREFIX."tracker (
  user_id int(10) unsigned NOT NULL auto_increment,
  user_name varchar(100) NOT NULL default '',
  user_sex varchar(100) NOT NULL default '',
  user_enable tinyint(1) NOT NULL default '0',
  user_color varchar(150) NOT NULL default '',
  user_pref varchar(50) default NULL,
  user_date varchar(12) default NULL,
  PRIMARY KEY  (user_id),
  UNIQUE KEY user_name (user_name)
) TYPE=MyISAM;",

        "CREATE TABLE ".MPREFIX."namemap (
  info_hash varchar(40) NOT NULL default '',
  filename varchar(250) NOT NULL default '',
  url varchar(250) NOT NULL default '',
  info varchar(250) NOT NULL default '',
  PRIMARY KEY  (info_hash)
) TYPE=MyISAM;",

        "CREATE TABLE ".MPREFIX."summary (
  info_hash char(40) NOT NULL default '',
  dlbytes bigint(20) unsigned NOT NULL default '0',
  seeds int(10) unsigned NOT NULL default '0',
  leechers int(10) unsigned NOT NULL default '0',
  finished int(10) unsigned NOT NULL default '0',
  lastcycle int(10) unsigned NOT NULL default '0',
  lastSpeedCycle int(10) unsigned NOT NULL default '0',
  speed bigint(20) unsigned NOT NULL default '0',
  PRIMARY KEY  (info_hash)
) TYPE=MyISAM;",

        "CREATE TABLE ".MPREFIX."timestamps (
  info_hash char(40) NOT NULL default '',
  sequence int(10) unsigned NOT NULL auto_increment,
  bytes bigint(20) unsigned NOT NULL default '0',
  delta smallint(5) unsigned NOT NULL default '0',
  PRIMARY KEY  (sequence),
  KEY sorting (info_hash)
) TYPE=MyISAM AUTO_INCREMENT=1 ;");



// Create a link in main menu (yes=TRUE, no=FALSE) -------------------------------------------------------------
$eplug_link = TRUE;
$eplug_link_name = "E107 Tracker";
$eplug_link_url = "e107_plugins/bt_e107/index.php";


// Text to display after plugin successfully installed ------------------------------------------------------------------
$eplug_done = "Installation Successful..";

?>